#include <bits/stdc++.h>
using namespace std;

int n, o, a, b, ab;
bool m = true;

struct Pacijent
{
    int O;
    int A;
    int B;
    int AB;
};

Pacijent getPacijent(string s, int k)
{
    Pacijent p;

    p.O = 0;
    p.A = 0;
    p.B = 0;
    p.AB = 0;

    if(s == "O")
    {
        if(o >= k)
        {
            p.O = k;
            o -= k;
        }
        else m = false;
    }

    else if(s == "A")
    {
        if(a >= k)
        {
            p.A = k;
            a -= k;
        }
        else if(o >= k - a)
        {
            p.A = a;
            p.O = k - a;
            a = 0;
            o -= k - a;
        }
        else m = false;
    }

    else if(s == "B")
    {
        if(b >= k)
        {
            p.B = k;
            b -= k;
        }
        else if(o >= k - b)
        {
            p.B = b;
            p.O = k - b;
            b = 0;
            o -= k - b;
        }
        else m = false;
    }

    else
    {
        if(ab >= k)
        {
            p.AB = k;
            ab -= k;
        }
        else if(a >= k - ab)
        {
            p.AB = ab;
            p.A = k - ab;
            ab = 0;
            a -= k - ab;
        }
        else if(b >= k - ab - a)
        {
            p.AB = ab;
            p.A = a;
            p.B = k - ab - a;
            ab = 0;
            a = 0;
            b -= k - ab - a;
        }
        else if(o >= k - ab - a - b)
        {
            p.AB = ab;
            p.A = a;
            p.B = b;
            p.O = k - ab - a - b;
            ab = 0;
            a = 0;
            b = 0;
            o -= k - ab - a - b;
        }
        else m = false;
    }

    return p;
}

int main()
{
    cin >> n >> o >> a >> b >> ab;

    string s;
    int k;

    vector<Pacijent> pacijenti(n);

    for(int i = 0; i < n; ++i)
    {
        cin >> s >> k;
        if(m) pacijenti[i] = getPacijent(s, k);
    }

    if(m)
    {
        cout << "moguce" << endl;

        for(int i = 0; i < n; ++i)
            cout << pacijenti[i].O << " "
                 << pacijenti[i].A << " "
                 << pacijenti[i].B << " "
                 << pacijenti[i].AB << endl;
    }
    else cout << "nemoguce" << endl;

    return 0;
}